# TPK4186 - Advanced Tools for Performance Engineering
# Fibonacci.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Recursive version
def FibonacciRecursive(n):
  if n==0:
    return 1
  if n==1:
    return 1
  return FibonacciRecursive(n-1) + FibonacciRecursive(n-2)

print("FibonacciRecursive(30) = " + str(FibonacciRecursive(30)))
print("FibonacciRecursive(32) = " + str(FibonacciRecursive(32)))
print("FibonacciRecursive(34) = " + str(FibonacciRecursive(34)))
print("FibonacciRecursive(36) = " + str(FibonacciRecursive(36)))

# Version with a loop
def FibonacciLoop(n):
  f0 = 1
  f1 = 1
  for i in range(2, n+1):
    f2 = f1 + f0
    f0 = f1
    f1 = f2
  return f1

# Tests
print("FibonacciLoop(30) = " + str(FibonacciLoop(30)))
print("FibonacciLoop(32) = " + str(FibonacciLoop(32)))
print("FibonacciLoop(34) = " + str(FibonacciLoop(34)))
print("FibonacciLoop(36) = " + str(FibonacciLoop(36)))
