# TPK4186 - Advanced Tools for Performance Engineering
# SecantMethod.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.
#
# Required modules
import sys
import math

# Coefficients
epsilon = 1.0e-10

# Initialization
x0 = 0.0
# f0 = x0**2 - 4*x0 - 5
f0 = math.cos(x0) + 2*math.sin(x0) + x0**2
if math.fabs(f0)<=epsilon:
  print("Solution (0 iteration): " + str(x0))
  sys.exit()

x1 = 1.0
# f1 = x1**2 - 4*x1 - 5
f1 = math.cos(x1) + 2*math.sin(x1) + x1**2
if math.fabs(f1)<=epsilon:
  print("Solution (0 iteration): " + str(x1))
  sys.exit()

x2 = x1 - f1*(x1-x0)/(f1-f0)
# f2 = x2**2 - 4*x2 - 5
f2 = math.cos(x2) + 2*math.sin(x2) + x2**2
numberOfIterations = 0
while math.fabs(f2)>epsilon:
  x0 = x1
  f0 = f1
  x1 = x2
  f1 = f2
  x2 = x1 - f1*(x1-x0)/(f1-f0)
  # f2 = x2**2 - 4*x2 - 5
  f2 = math.cos(x2) + 2*math.sin(x2) + x2**2
  numberOfIterations += 1
  
print("Solution (" + str(numberOfIterations) + " iteration): " + str(x2))


