# TPK4186 - Advanced Tools for Performance Engineering
# SecondDegreeEquations.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import math

# Coefficients
a = 1
b = -4
c = -5

# Calculation of the determinant
det = b**2 - 4*a*c

# Determination of solutions, if any
if det<0:
  print("No solution")
elif det==0:
  sol = -b/(2*a)
  print("Solution: " + str(sol))
else:
  sol1 = (-b - math.sqrt(det)) / (2*a)
  sol2 = (-b + math.sqrt(det)) / (2*a)
  print("Solutions: " + str(sol1) + ", " + str(sol2))
